Subject: Re: [PATCH net-next-2.6] netns: call ops_free right after ops_exit

From: Jiri Pirko <[email-masked]>
Date: Sun, 25 Apr 2010 20:44:31 +0200

Sun, Apr 25, 2010 at 04:50:34PM CEST, [email-masked] wrote:
>David Miller <[email-masked]> writes:
>
>> From: Jiri Pirko <[email-masked]>
>> Date: Sun, 25 Apr 2010 11:26:01 +0200
>>
>>> There's no need to iterate this twice. We can free net generic
>>> variables right after exit is called.
>>>
>>> Signed-off-by: Jiri Pirko <[email-masked]>
>>
>> Are you sure there are no problems with doing this?
>>
>> What if there are inter-net variable reference dependencies
>> or something like that?
>>
>> I really suspect it is being done this way on purpose, but
>> in the end I defer to experts like Eric B. :-)
>
>I am pretty certain there is a problem.  My memory is fuzzy this
>morning but I believe we can have rcu references between various
>pieces of the networking stack for a single network namespace.  So we
>need to cause all of the network namespace to exit before it is safe
>to free those pieces.

Hmm, that doesn't make much sense to me. Since the allocated memory in question
is used locally, after exit() is called, the memory chunk should not be used by
anyone and if it is, I think it's a bug.

Earlier, when the memory wasn't allocated automatically (by filling .size)
memory was individually freed in exit(). From what I understood from your reply,
you are telling this was buggy?

Jirka

>Eric